// Breakout // // 28/02/2007
// Steph Thirion - Game Mod workshop: < http://trsp.net/teaching/gamemod >
// 
// english version :)
// made with Processing 0124 Beta

// Modified by Burt du Preez 02/06/2014

// BALL

import java.awt.geom.*;

public class Ball {

  Rectangle rectangle;
  // BALL PROPERTIES --
  int ballWidth = 2;
  int ballHeight = 2;
  boolean hasStroke = false;
  color strokeColor = #FFFFFF;
  boolean hasFill = true;
  color fillColor = #ffffff;
  // velocity
  double velX = 3;
  double velY = 3;
  //
  int x;
  int y;
  int ox;
  int oy;
  int xcentre;
  int ycentre;
  
 int OffsetY = 0;
int OffsetX = 0;
Brick[][] bricks;
PImage[] fBuilding;


  Ball(int X, int Y,int offX,int offY, Brick[][] bricks,PImage[] fBuilding,int setColor) {
    x = X;
    y = Y;
    OffsetY = offY;
    OffsetX = offX;
    
    //this.set = set;
    this.bricks = bricks;
    this.fBuilding = fBuilding;
    
    switch(setColor)
    {
      case 0: fillColor = color(255,124,0);
      break;
      case 1:fillColor = color(247,203,0);
      break;
      case 2:fillColor = color(0,234,72);
      break;
      case 3:fillColor = color(57,226,178);
      break;
      case 4:fillColor = color(180,255,241);
      break;
      default: fillColor = color(0,0,0);
      break;
    }
    
    fillColor = color(247,203,0);//color(0,0,0);
    rectangle = new Rectangle(ballWidth, ballHeight, hasStroke, strokeColor, hasFill, fillColor);
    rectangle.setPosition(x, y);
    
    
  }
  
  
  

  void refresh(){
    updatePosition();
    rectangle.setPosition(x, y);
    rectangle.drawYourself();
  }
  
  
  

  void updatePosition() {
    // add velocity to position
    x+=velX+(Math.random()*1-1.0);
    y+=velY+(Math.random()*1-1.0);
    
    // collision with limits
    if(x<=0+OffsetX || x>=gameFrameWidth-ballWidth+OffsetX){
      velX = -velX;//+(Math.random()-1.0);
      x = constrain(x, 0+OffsetX, gameFrameWidth-ballWidth+OffsetX);
    }
    if(y<=0+OffsetY || y>=gameFrameHeight-ballHeight+OffsetY){
      velY = -velY;//+(Math.random()-1.0);
      y = constrain(y, 0+OffsetY, gameFrameHeight-ballHeight+OffsetY);
    }
    xcentre = x+ballWidth/2;
    ycentre = y+ballHeight/2;
    // collision with mouse
   /* Rectangle mouseRec = new Rectangle(30, 30, false, strokeColor, false, fillColor);
    mouseRec.setPosition(mouseX-15,mouseY-15);
    
    int result = checkCollisionWithRectangle(mouseRec);
    // if collides on top, control direction of ball
    if (result == 1){
        if(xcentre < mouseRec.x1+mouseRec.recWidth/2){
          if(velX>0){
            velX = -velX;  
          }
        }else{
          if(velX<0){
            velX = -velX;  
          }
        }
    }*/
    // collision with bricks

   for(int s = 0; s < 3;s++)
      for (int i=0; i<bricks[s].length; i++){
         if(bricks[s][i].imAlive){
           int res = checkCollisionWithRectangle(bricks[s][i].rectangle);
           if (res != 0){
             fBuilding[s].loadPixels();
             if(i <= fBuilding[s].pixels.length)
             fBuilding[s].pixels[fBuilding[s].pixels.length-i] = color(0,0,0,0);
             fBuilding[s].updatePixels();
             bricks[s][i].die();
             break;
           }
         }
      }
   // }
    ox = x;
    oy = y;
  }
  
  
  // FUNCION DETECCION DE COLISION --
  // result: 0: no collision 1: top 2: right 3: bottom 4: left 5: couldn't detect which side
  int checkCollisionWithRectangle (Rectangle R){
    int result = 0;
    if (R.doesPointTouchMe(xcentre, ycentre)){
      // which side did it collide
      Line2D lineaBola = new Line2D.Float(xcentre,ycentre,ox+ballWidth/2,oy+ballHeight/2);
      result = R.whatSideDoesLineTouch(lineaBola, velX, velY);
      // top
      if(result==1){
        velY = -velY;
        y = R.y1-ballHeight;
        // right
      }else if(result==2){
        velX = -velX;
        x = R.x2;
        // bottom
      }else if(result==3){
        velY = -velY;
        y = R.y2;
        // left
      }else if(result==4){
        velX = -velX;
        x = R.x1-ballWidth;
      }else{
        result = 5;
      }
    }
    return result;
  }
  

}

